



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
        <meta name="description" content="我的技术笔记本~">
      
      
      
        <meta name="author" content="chenyuan">
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-0.17.2, mkdocs-material-2.5.3">
    
    
      
        <title>Home - notebook</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/application.aa3de92b.css">
      
    
    
      <script src="../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      
        <link rel="stylesheet" href="https://fonts.loli.net/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
      <link rel="stylesheet" href="https://fonts.loli.net/icon?family=Material+Icons">
    
    
    
  </head>
  
  
    <body dir="ltr">
  
    <svg class="md-svg">
      <defs>
        
        
          <svg xmlns="http://www.w3.org/2000/svg" width="416" height="448" viewBox="0 0 416 448" id="github"><path fill="currentColor" d="M160 304q0 10-3.125 20.5t-10.75 19T128 352t-18.125-8.5-10.75-19T96 304t3.125-20.5 10.75-19T128 256t18.125 8.5 10.75 19T160 304zm160 0q0 10-3.125 20.5t-10.75 19T288 352t-18.125-8.5-10.75-19T256 304t3.125-20.5 10.75-19T288 256t18.125 8.5 10.75 19T320 304zm40 0q0-30-17.25-51T296 232q-10.25 0-48.75 5.25Q229.5 240 208 240t-39.25-2.75Q130.75 232 120 232q-29.5 0-46.75 21T56 304q0 22 8 38.375t20.25 25.75 30.5 15 35 7.375 37.25 1.75h42q20.5 0 37.25-1.75t35-7.375 30.5-15 20.25-25.75T360 304zm56-44q0 51.75-15.25 82.75-9.5 19.25-26.375 33.25t-35.25 21.5-42.5 11.875-42.875 5.5T212 416q-19.5 0-35.5-.75t-36.875-3.125-38.125-7.5-34.25-12.875T37 371.5t-21.5-28.75Q0 312 0 260q0-59.25 34-99-6.75-20.5-6.75-42.5 0-29 12.75-54.5 27 0 47.5 9.875t47.25 30.875Q171.5 96 212 96q37 0 70 8 26.25-20.5 46.75-30.25T376 64q12.75 25.5 12.75 54.5 0 21.75-6.75 42 34 40 34 99.5z"/></svg>
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="drawer">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="search">
    <label class="md-overlay" data-md-component="overlay" for="drawer"></label>
    
      <a href="#zjuchenyuans-notebook" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href="./" title="notebook" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                notebook
              </span>
              <span class="md-header-nav__topic">
                Home
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
        <div class="md-flex__cell md-flex__cell--shrink">
          <div class="md-header-nav__source">
            


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

          </div>
        </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="drawer">
    <span class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </span>
    notebook
  </label>
  
    <div class="md-nav__source">
      


  


  <a href="https://github.com/zjuchenyuan/notebook/" title="Go to repository" class="md-source" data-md-source="github">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#github" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      GitHub
    </div>
  </a>

    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="toc">
        Home
      </label>
    
    <a href="./" title="Home" class="md-nav__link md-nav__link--active">
      Home
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#python" title="Python" class="md-nav__link">
    Python
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#gist-python" title="gist Python一些常用的代码片段" class="md-nav__link">
    gist Python一些常用的代码片段
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bash" title="BASH" class="md-nav__link">
    BASH
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bat" title="BAT 批处理" class="md-nav__link">
    BAT 批处理
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#c" title="C 语言" class="md-nav__link">
    C 语言
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#cc98-oauth2" title="CC98 OAuth2 登录/用户验证" class="md-nav__link">
    CC98 OAuth2 登录/用户验证
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#cdn" title="CDN" class="md-nav__link">
    CDN
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#curl" title="cURL" class="md-nav__link">
    cURL
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#developer" title="Developer" class="md-nav__link">
    Developer
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#docker" title="Docker" class="md-nav__link">
    Docker
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#favorites" title="Favorites" class="md-nav__link">
    Favorites
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#flask" title="Flask" class="md-nav__link">
    Flask
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git" title="Git" class="md-nav__link">
    Git
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#github-project-recommendation" title="Github Project Recommendation" class="md-nav__link">
    Github Project Recommendation
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#java" title="Java" class="md-nav__link">
    Java
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#javascript" title="JavaScript" class="md-nav__link">
    JavaScript
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#jekyll" title="Jekyll" class="md-nav__link">
    Jekyll
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-setup" title="Linux-setup" class="md-nav__link">
    Linux-setup
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-ssh" title="Linux-SSH" class="md-nav__link">
    Linux-SSH
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-cli" title="Linux-cli" class="md-nav__link">
    Linux-cli
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-backup" title="Linux-backup" class="md-nav__link">
    Linux-backup
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#mysql" title="MySQL" class="md-nav__link">
    MySQL
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#nginx" title="Nginx" class="md-nav__link">
    Nginx
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#php" title="PHP" class="md-nav__link">
    PHP
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#rabbitmq" title="RabbitMQ" class="md-nav__link">
    RabbitMQ
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#ubuntu" title="Ubuntu桌面版" class="md-nav__link">
    Ubuntu桌面版
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#virtualbox" title="VirtualBox" class="md-nav__link">
    VirtualBox
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#winsoftware" title="WinSoftware" class="md-nav__link">
    WinSoftware
  </a>
  
</li>
      
      
      
    </ul>
  
</nav>
    
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2" type="checkbox" id="nav-2">
    
    <label class="md-nav__link" for="nav-2">
      Python
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-2">
        Python
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Python/" title="Python" class="md-nav__link">
      Python
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../gist/" title="Gist Python一些常用代码片段" class="md-nav__link">
      Gist Python一些常用代码片段
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3" type="checkbox" id="nav-3">
    
    <label class="md-nav__link" for="nav-3">
      Programming Languages
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-3">
        Programming Languages
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../BASH/" title="BASH" class="md-nav__link">
      BASH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../BAT/" title="BAT批处理" class="md-nav__link">
      BAT批处理
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../C/" title="C语言" class="md-nav__link">
      C语言
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3-4" type="checkbox" id="nav-3-4">
    
    <label class="md-nav__link" for="nav-3-4">
      Java
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-3-4">
        Java
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Java/" title="Java" class="md-nav__link">
      Java
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../S2-045/" title="S2-045" class="md-nav__link">
      S2-045
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../JavaScript/" title="JavaScript" class="md-nav__link">
      JavaScript
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../PHP/" title="PHP" class="md-nav__link">
      PHP
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4" type="checkbox" id="nav-4">
    
    <label class="md-nav__link" for="nav-4">
      Web
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-4">
        Web
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../CDN/" title="CDN" class="md-nav__link">
      CDN
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../cURL/" title="cURL" class="md-nav__link">
      cURL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-4-3" type="checkbox" id="nav-4-3">
    
    <label class="md-nav__link" for="nav-4-3">
      Favorites
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="2">
      <label class="md-nav__title" for="nav-4-3">
        Favorites
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Favorites/" title="Favorites" class="md-nav__link">
      Favorites
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../GithubProjectRecommendation/" title="Github Project Recommendation" class="md-nav__link">
      Github Project Recommendation
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Links/" title="更多链接" class="md-nav__link">
      更多链接
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Flask/" title="Flask" class="md-nav__link">
      Flask
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../MySQL/" title="MySQL" class="md-nav__link">
      MySQL
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Nginx/" title="Nginx" class="md-nav__link">
      Nginx
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../RabbitMQ/" title="RabbitMQ" class="md-nav__link">
      RabbitMQ
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-5" type="checkbox" id="nav-5">
    
    <label class="md-nav__link" for="nav-5">
      Development
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-5">
        Development
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Developer/" title="Developer" class="md-nav__link">
      Developer
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Docker/" title="Docker" class="md-nav__link">
      Docker
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Git/" title="Git" class="md-nav__link">
      Git
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Jekyll/" title="Jekyll" class="md-nav__link">
      Jekyll
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../WindowsSoftware/" title="WindowsSoftware" class="md-nav__link">
      WindowsSoftware
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-6" type="checkbox" id="nav-6">
    
    <label class="md-nav__link" for="nav-6">
      Linux
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-6">
        Linux
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-backup/" title="Linux-backup" class="md-nav__link">
      Linux-backup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-setup/" title="Linux-setup" class="md-nav__link">
      Linux-setup
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-SSH/" title="Linux-SSH" class="md-nav__link">
      Linux-SSH
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-cli/" title="Linux-cli" class="md-nav__link">
      Linux-cli
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Linux-VirtualBox/" title="Linux-VirtualBox" class="md-nav__link">
      Linux-VirtualBox
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../Ubuntu/" title="Ubuntu" class="md-nav__link">
      Ubuntu
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-7" type="checkbox" id="nav-7">
    
    <label class="md-nav__link" for="nav-7">
      My Projects
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-7">
        My Projects
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../zjugrshelper/" title="ZJU grs helper" class="md-nav__link">
      ZJU grs helper
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#python" title="Python" class="md-nav__link">
    Python
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#gist-python" title="gist Python一些常用的代码片段" class="md-nav__link">
    gist Python一些常用的代码片段
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bash" title="BASH" class="md-nav__link">
    BASH
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#bat" title="BAT 批处理" class="md-nav__link">
    BAT 批处理
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#c" title="C 语言" class="md-nav__link">
    C 语言
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#cc98-oauth2" title="CC98 OAuth2 登录/用户验证" class="md-nav__link">
    CC98 OAuth2 登录/用户验证
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#cdn" title="CDN" class="md-nav__link">
    CDN
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#curl" title="cURL" class="md-nav__link">
    cURL
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#developer" title="Developer" class="md-nav__link">
    Developer
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#docker" title="Docker" class="md-nav__link">
    Docker
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#favorites" title="Favorites" class="md-nav__link">
    Favorites
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#flask" title="Flask" class="md-nav__link">
    Flask
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#git" title="Git" class="md-nav__link">
    Git
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#github-project-recommendation" title="Github Project Recommendation" class="md-nav__link">
    Github Project Recommendation
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#java" title="Java" class="md-nav__link">
    Java
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#javascript" title="JavaScript" class="md-nav__link">
    JavaScript
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#jekyll" title="Jekyll" class="md-nav__link">
    Jekyll
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-setup" title="Linux-setup" class="md-nav__link">
    Linux-setup
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-ssh" title="Linux-SSH" class="md-nav__link">
    Linux-SSH
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-cli" title="Linux-cli" class="md-nav__link">
    Linux-cli
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#linux-backup" title="Linux-backup" class="md-nav__link">
    Linux-backup
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#mysql" title="MySQL" class="md-nav__link">
    MySQL
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#nginx" title="Nginx" class="md-nav__link">
    Nginx
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#php" title="PHP" class="md-nav__link">
    PHP
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#rabbitmq" title="RabbitMQ" class="md-nav__link">
    RabbitMQ
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#ubuntu" title="Ubuntu桌面版" class="md-nav__link">
    Ubuntu桌面版
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#virtualbox" title="VirtualBox" class="md-nav__link">
    VirtualBox
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#winsoftware" title="WinSoftware" class="md-nav__link">
    WinSoftware
  </a>
  
</li>
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://github.com/zjuchenyuan/notebook/edit/master/README.md" title="Edit this page" class="md-icon md-content__icon">&#xE3C9;</a>
                
                
                <h1 id="zjuchenyuans-notebook">zjuchenyuan&rsquo;s Notebook<a class="headerlink" href="#zjuchenyuans-notebook" title="Permanent link">&para;</a></h1>
<p>My notebook about technology, for lookup and share</p>
<p>这份列表是手工维护的目录，没有实现链接功能（可以直接点的是代码文件）</p>
<p>查看内容 请点击Topic标题（如<a href="../Docker/">Docker</a>）进入页面后使用右侧目录定位</p>
<p>评论请使用: <a href="https://github.com/zjuchenyuan/notebook/issues/1">Github Issue</a></p>
<h2 id="python"><a href="../Python/">Python</a><a class="headerlink" href="#python" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li><a href="https://py3.io/doc/python/quickstart.html">语言勾勒QuickStart</a></li>
<li>设置pip源</li>
<li>反弹shell 获得tty</li>
<li>requests使用多IP请求</li>
<li><a href="../code/MultiThread_Template.py">Python多线程模板</a></li>
<li>http.server（BaseHTTPServer）并发性改善 不必修改库文件</li>
<li>无root权限安装Python</li>
<li>中文输出乱码问题解决</li>
<li>pycodestyle检查代码风格</li>
<li>生成随机字符串</li>
<li>别对大的list循环使用in，应该改用set</li>
<li>解决Python.h: No such file or directory</li>
<li>二进制字符串转普通字符串</li>
<li>十六进制字符串转bytes字符串</li>
<li>用Python3写PAT心得</li>
<li>用requests进行post</li>
<li>通过tkinter获取/修改剪贴板</li>
<li>符号数与无符号数转换</li>
<li>使用signal.SIGALRM在限定时间后退出进程</li>
<li>捕捉用户的Ctrl+C</li>
<li>使用signal.SIGALRM实现定时器</li>
<li>使用pdb进行调试</li>
<li><a href="../code/decisiontree.py">机器学习-决策树</a></li>
<li>使用Python开发阿里云函数计算后端服务</li>
<li>修复gbk编码的文件名</li>
<li>Crack RSA! 破解短长度密钥的RSA加密</li>
<li>时间戳与字符串相互转换</li>
<li>用redis存储字典</li>
<li>python selenium+Docker chrome headless爬复杂网页</li>
<li>python transmissionrpc 上传种子 获取状态 增加tracker 修改torrent文件中的tracker</li>
<li>uwsgi优雅重启</li>
<li>flask设置一堆静态目录</li>
<li>Python3.5 open打开文件默认使用utf-8</li>
</ul>
</blockquote>
<h2 id="gist-python"><a href="../gist/">gist Python一些常用的代码片段</a><a class="headerlink" href="#gist-python" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>连接mysql插入、查询</li>
<li>flask设置一堆静态目录</li>
<li>大小写不敏感字典</li>
<li>print的时候顺带带上时间</li>
<li>mpms多线程下每个线程单独变量</li>
<li>使用AES加密字符串 pyaes库</li>
</ul>
</blockquote>
<h2 id="bash"><a href="../BASH/">BASH</a><a class="headerlink" href="#bash" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>在bash脚本中使用alias</li>
<li>判断命令行参数是否为空</li>
<li>for循环</li>
<li>判断命令、文件是否存在</li>
</ul>
</blockquote>
<h2 id="bat"><a href="../BAT/">BAT 批处理</a><a class="headerlink" href="#bat" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>快速打开cmd</li>
<li>并列语句语法</li>
<li>循环for</li>
<li>结束进程taskkill</li>
<li>内存整理free</li>
<li>睡一会SleepX</li>
<li>判断文件夹存在</li>
<li>创建硬链接mklink或者fsutil hardlink create</li>
<li>端口转发</li>
<li><a href="../code/RVPNKeepAlive.bat">保持RVPN不断开</a></li>
<li>vpn静态路由配置</li>
<li>进入休眠</li>
<li>快速进入系统代理设置，不用打开IE</li>
<li>在普通权限cmd中获得更高权限</li>
<li>命令行配置IP</li>
<li>命令行使用VeraCrypt</li>
<li>命令行临时关闭Windows Defender</li>
</ul>
</blockquote>
<h2 id="c"><a href="../C/">C 语言</a><a class="headerlink" href="#c" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>关于Dev C++</li>
<li>输入的问题，建议用gets和sscanf</li>
<li>C++用sstream代替sprintf</li>
<li>g++省略拷贝构造函数的问题</li>
<li>[数据结构]树的遍历</li>
<li>对一个const的vector使用迭代器要用const_iterator</li>
<li>小心未初始化的变量</li>
<li>获取文件大小</li>
<li>题目解析 (结构指针、结构数组&hellip;)</li>
</ul>
</blockquote>
<h2 id="cc98-oauth2"><a href="CC98.md">CC98 OAuth2 登录/用户验证</a><a class="headerlink" href="#cc98-oauth2" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>使用CC98 OAuth Login完成cc98_api登录</li>
<li>如何接入CC98 OAuth2 进行用户验证(旧版)</li>
</ul>
</blockquote>
<h2 id="cdn"><a href="../CDN/">CDN</a><a class="headerlink" href="#cdn" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>·UPYUN 又拍云</li>
<li>管理文件可以用FTP，UpyunManager，Upx</li>
<li>python规则刷新，python调用官方API进行URL刷新</li>
<li>使用upyun提供的webp功能节省流量</li>
<li>使用边缘规则修复改版导致的404问题</li>
<li>使用边缘规则实现upyun TOKEN反盗链功能</li>
<li>·Qiniu 七牛</li>
<li>使用qshell上传文件夹</li>
</ul>
</blockquote>
<h2 id="curl"><a href="../cURL/">cURL</a><a class="headerlink" href="#curl" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>模拟浏览器请求</li>
<li>基本教程</li>
<li>还可以循环哟</li>
<li>wget在0b/s时自动重连</li>
</ul>
</blockquote>
<h2 id="developer"><a href="../Developer/">Developer</a><a class="headerlink" href="#developer" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>保持技术精进</li>
<li>如何明智地向程序员提问</li>
<li>使用chrome缓存找到被删的qq空间的图片</li>
</ul>
</blockquote>
<h2 id="docker"><a href="../Docker/">Docker</a><a class="headerlink" href="#docker" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>myubuntu 基础镜像</li>
<li>安装</li>
<li>加速镜像下载</li>
<li>旧版本卸载</li>
<li>获得容器的ip</li>
<li>导入导出容器</li>
<li>解决iptables failed问题</li>
<li>迁移Docker文件夹到其他硬盘</li>
<li>解决debian等容器没有ifconfig的问题</li>
<li>设置容器低权限用户运行</li>
<li>设置容器/etc/resolv.conf和/etc/hosts</li>
<li>容器限制参数设置</li>
<li>快速部署ftp</li>
<li>快速部署wordpress</li>
<li>Dockerfile 中的 apt-get 静默执行</li>
<li>让Docker容器得到内网IP</li>
<li>使用iptables端口转发让Docker容器得到内网IP</li>
<li>快速部署samba</li>
<li>[CTF]按需分配容器 过期自动销毁</li>
<li>在容器A中使用别名访问容器B</li>
<li>修复Docker更新到18.02后部分容器无法start的问题</li>
<li>解决docker exec -it进入容器屏幕大小不对的问题</li>
<li>启动另一个Docker Daemon进程</li>
<li>配置使用Docker版本的Gitlab CI</li>
<li>为已经存在的容器创建临时端口映射 socat</li>
<li>运行中的容器添加目录挂载</li>
</ul>
</blockquote>
<h2 id="favorites"><a href="../Favorites/">Favorites</a><a class="headerlink" href="#favorites" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>Intel i386 手册 及 勘误</li>
<li>ASCII字符图案生成</li>
<li>解释Shell命令每个参数</li>
<li>安全会议的排名 建议读的论文</li>
<li><a href="../Links/">More Links</a></li>
<li>Git Emoji</li>
</ul>
</blockquote>
<h2 id="flask"><a href="../Flask/">Flask</a><a class="headerlink" href="#flask" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>应用根目录APP_ROOT</li>
<li>render_template引入所有全局变量+局部变量</li>
<li>判断是否手机访问 g.isphone</li>
</ul>
</blockquote>
<h2 id="git"><a href="../Git/">Git</a><a class="headerlink" href="#git" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>立即使用</li>
<li>git clone加速 &ndash;depth 1</li>
<li><a href="../code/ssgit.txt">git push加速</a></li>
<li>git push免密码</li>
<li>bash工作环境(别名,自动完成,dirty提示)设置</li>
<li>好玩的命令们</li>
<li>gitignore负向选择</li>
<li>补上commit漏掉的文件 &ndash;amend</li>
<li>密码泄露查作者 blame</li>
<li>文件一次性改太多了，拆成多次提交 add -p</li>
<li>本地忽略一些个人的修改</li>
<li>本地创建branch后push操作git push -u</li>
<li>用gpg给git提交签名</li>
</ul>
</blockquote>
<h2 id="github-project-recommendation"><a href="../GithubProjectRecommendation/">Github Project Recommendation</a><a class="headerlink" href="#github-project-recommendation" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>视频下载you-get</li>
<li>记忆手段Anki</li>
<li>在线评测OnlineJudge</li>
<li>Python也能用来解方程sympy</li>
<li>让网站链接秒开InstantClick</li>
</ul>
</blockquote>
<h2 id="java"><a href="../Java/">Java</a><a class="headerlink" href="#java" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>一些Java与C++的不同之处</li>
<li>异常处理中的资源释放问题</li>
<li>JVM启动时的内存参数</li>
<li><a href="../S2-045/">修复Struts2的S2-045漏洞</a></li>
</ul>
</blockquote>
<h2 id="javascript"><a href="../JavaScript/">JavaScript</a><a class="headerlink" href="#javascript" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>使用本地存储localStorage</li>
<li><a href="http://py3.io/p.html">随机字符串生成</a></li>
<li>异常</li>
<li>使用phantomjs爬取网页</li>
<li>jQuery绑定&rdquo;变为可见&rdquo;事件</li>
<li>读取GET参数</li>
<li>使用 Github Issue 作为博客评论区</li>
<li>history.replaceState修改历史记录</li>
<li>记住一个checkbox的状态</li>
</ul>
</blockquote>
<h2 id="jekyll"><a href="../Jekyll/">Jekyll</a><a class="headerlink" href="#jekyll" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>碰到过的坑</li>
<li>配置代码高亮并显示行号</li>
<li>解决Github Metadata Warning</li>
<li>安装Jekyll</li>
</ul>
</blockquote>
<h2 id="linux-setup"><a href="../Linux-setup/">Linux-setup</a><a class="headerlink" href="#linux-setup" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li><a href="../code/ssprivoxy.txt">网络加速privoxy</a></li>
<li>配置有线静态IP</li>
<li>使用ifconfig修改ip后记得要重新配route</li>
<li>配置apt源以加速国内环境下apt速度</li>
<li>单网卡获得多个IP</li>
<li>锐速安装</li>
<li>解决apt依赖问题</li>
<li>UnixBench性能评测</li>
<li>清除内存缓存</li>
<li>使用iptables封ip</li>
<li>iptables只允许特定IP访问某端口</li>
<li>无root权限使用screen</li>
<li>screen的用法</li>
<li>两条iptables实现端口转发，暴露内网端口</li>
<li>保护重要系统文件防止被删chattr +i</li>
<li>时区设置</li>
<li>查看CPU核心个数</li>
<li>非交互式添加用户</li>
<li>简单OpenVPN配置</li>
<li>时区时间设置</li>
<li>快速地格式化大分区ext4</li>
<li>明明还有大量空间却说没有？inode满了！挂载单个文件为btrfs分区</li>
<li>安全地拔出移动硬盘</li>
</ul>
</blockquote>
<h2 id="linux-ssh"><a href="../Linux-SSH/">Linux-SSH</a><a class="headerlink" href="#linux-ssh" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>客户端不同服务器使用不同的id_rsa</li>
<li>换个端口开启一个临时的sshd</li>
<li>ssh反向代理</li>
<li>启用SSH密钥登录后两步验证</li>
<li>ssh登录禁用默认的信息显示 Ubuntu</li>
</ul>
</blockquote>
<h2 id="linux-cli"><a href="../Linux-cli/">Linux-cli</a><a class="headerlink" href="#linux-cli" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>查看内置命令的帮助</li>
<li>grep搜索帮助文档</li>
<li>帮助文本的grep 用2&gt;&amp;1</li>
<li>各种解压命令</li>
<li>当前目录文件全文搜索</li>
<li>统计当前文件夹代码行数</li>
<li>查看给定文件列表的文件大小</li>
<li>wget慢慢下载</li>
<li>touch修改时间戳</li>
<li>去掉Ubuntu默认情况下ls的颜色</li>
<li>换行方式修改</li>
<li>iodine&ndash;使用DNS传输数据</li>
<li>远程控制Windows</li>
<li>统计以特定字符串开头的文件数目</li>
<li>hexdump查看字符内部编码</li>
<li>子目录大小排序</li>
<li>安装ffmpeg</li>
<li>修改readonly的变量</li>
<li>永久等待 sleep infinity</li>
<li>zmap扫描整个网段特定开放端口</li>
<li>对ip列表批量测试redis未授权漏洞</li>
<li>使用ImageMagick对图像进行裁剪</li>
<li>查找0字节的文件并删除</li>
<li>用vim去除\r换行符 :set ff=unix</li>
<li>watch持续观察命令输出</li>
<li>树莓派2上编译Truecrypt 7.1a，使用make -j5 -l4加速编译</li>
<li>scp目录断点续传</li>
<li>使用wget代替scp传输文件夹 避免无谓的加密性能损失（适用于树莓派）</li>
<li>清除已经断开的sshd进程</li>
<li>批量替换文本</li>
<li>使用cryptsetup挂载truecrypt分区</li>
<li>从二进制文件中提取片段</li>
<li>redis匹配前缀删除大量键值</li>
<li>批量替换子目录特定后缀名文件内容</li>
</ul>
</blockquote>
<h2 id="linux-backup"><a href="../Linux-backup/">Linux-backup</a><a class="headerlink" href="#linux-backup" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>一个良好安全的备份计划至关重要</li>
<li>用rsync代替scp</li>
</ul>
</blockquote>
<h2 id="mysql"><a href="../MySQL/">MySQL</a><a class="headerlink" href="#mysql" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>查看表结构 desc</li>
<li>MERGE存储引擎</li>
<li>删除表的冗余</li>
<li>修改表 alter table</li>
<li><a href="../code/pinyin.sql">将中文转为拼音的函数</a></li>
<li>从路径URL获取文件名称</li>
<li>查询优化&ndash;explain发现出现了using filesort；内存表索引的选择</li>
<li>内存表The table is full的解决</li>
<li>replace函数替换文本</li>
<li>简单的split功能，文本转数字</li>
<li>mysqld配置参数调优</li>
<li>支持emoji，从utf8升级到utf8mb4</li>
<li>解决 Too many open files 错误</li>
<li>解决ubuntu16.04上mysql被apt upgrade自动关闭的问题</li>
<li>NULL转0</li>
</ul>
</blockquote>
<h2 id="nginx"><a href="../Nginx/">Nginx</a><a class="headerlink" href="#nginx" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>Nginx思考题</li>
<li>普通资源允许POST</li>
<li>不带后缀的文件当成php执行</li>
<li>获得Let&rsquo;s encrypt免费https证书</li>
<li>使用acme.sh获得泛域名证书</li>
<li>配置安全的https</li>
<li>反向代理之替换网页、JS中的文本</li>
<li>root与alias的区别</li>
<li>在bash on win10上使用Nginx</li>
<li>Nginx允许列目录</li>
</ul>
</blockquote>
<h2 id="php"><a href="../PHP/">PHP</a><a class="headerlink" href="#php" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>显示错误信息</li>
<li>全页面iframe</li>
</ul>
</blockquote>
<h2 id="rabbitmq"><a href="../RabbitMQ/">RabbitMQ</a><a class="headerlink" href="#rabbitmq" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>使用Docker部署</li>
<li>任务推送执行 代码示例</li>
</ul>
</blockquote>
<h2 id="ubuntu"><a href="../Ubuntu/">Ubuntu桌面版</a><a class="headerlink" href="#ubuntu" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>安装Google拼音后用上云候选功能</li>
</ul>
</blockquote>
<h2 id="virtualbox"><a href="../Linux-VirtualBox/">VirtualBox</a><a class="headerlink" href="#virtualbox" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>下载安装，一定记得安装额外包</li>
<li>创建虚拟机，设置虚拟机选项</li>
<li>启动虚拟机</li>
<li>远程控制虚拟机</li>
</ul>
</blockquote>
<h2 id="winsoftware"><a href="../WindowsSoftware/">WinSoftware</a><a class="headerlink" href="#winsoftware" title="Permanent link">&para;</a></h2>
<blockquote>
<ul>
<li>Emeditor</li>
<li>Everything</li>
<li>Sysinternals Utilities</li>
<li>CLOC代码统计利器</li>
<li>U盘安装原版系统盘</li>
<li>WinRAR</li>
<li>BurpSuite</li>
<li>BEncode Editor</li>
<li>Win10 Windows照片查看器</li>
</ul>
</blockquote>
                
                  
                
              
              
                
              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
        
          <a href="../Python/" title="Python" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Python
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
          <div class="md-footer-copyright__highlight">
            <a href=http://www.miitbeian.gov.cn/>浙ICP备15043819号-2</a>&nbsp;&nbsp;<a target=_blank href=http://www.beian.gov.cn/portal/registerSystemInfo?recordcode=33010602007826><img src="/assets/images/beian.png" height=14px>浙公网安备 33010602007826号</p></a>
          </div>
        
        powered by
        <a href="http://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
  <div class="md-footer-social">
    
    <link rel="stylesheet" href="https://cdnjs.loli.net/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    
      <a href="https://github.com/zjuchenyuan" class="md-footer-social__link fa fa-github-alt"></a>
    
      <a href="mailto: py3io.chenyuan@qiushi.ac.cn" class="md-footer-social__link fa fa-envelope"></a>
    
  </div>

      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/application.f041762f.js"></script>
      
      <script>app.initialize({version:"0.17.2",url:{base:".."}})</script>
      
        <script src="../assets/js/instantclick.min.js"></script>
      
    
    
      
    
  </body>
</html>